## trinity 1.2

=== Makefile ===
VERSION=1.2

INSTALL_PREFIX ?= $(DESTDIR)
INSTALL_PREFIX ?= $(HOME)

CC := $(CROSS_COMPILE)$(CC)
LD := $(CROSS_COMPILE)$(LD)

CFLAGS = -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE
#CFLAGS += $(shell if $(CC) -m32 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-m32"; fi)
CFLAGS += -Wdeclaration-after-statement
CFLAGS += -Wformat=2
CFLAGS += -Winit-self
CFLAGS += -Wlogical-op
CFLAGS += -Wnested-externs
CFLAGS += -Wpacked
CFLAGS += -Wshadow
CFLAGS += -Wstrict-aliasing=3
CFLAGS += -Wswitch-default
CFLAGS += -Wswitch-enum
CFLAGS += -Wundef
CFLAGS += -Wwrite-strings
CFLAGS += -Wstrict-prototypes -Wmissing-prototypes

# Only enabled during development.
#CFLAGS += -Werror

V	= @
Q	= $(V:1=)
QUIET_CC = $(Q:@=@echo    '  CC	'$@;)


all: trinity

test:
	@if [ ! -f config.h ]; then  echo "[1;31mRun configure.sh first.[0m" ; exit; fi


MACHINE		= $(shell $(CC) -dumpmachine)
SYSCALLS_ARCH	= $(shell case "$(MACHINE)" in \
		  (sh*) echo syscalls/sh/*.c ;; \
		  (ia64*) echo syscalls/ia64/*.c ;; \
		  esac)

HEADERS		= $(patsubst %.h,%.h,$(wildcard *.h)) $(patsubst %.h,%.h,$(wildcard syscalls/*.h)) $(patsubst %.h,%.h,$(wildcard ioctls/*.h))

SRCS		= $(wildcard *.c) \
		  $(wildcard syscalls/*.c) \
		  $(SYSCALLS_ARCH) \
		  $(wildcard ioctls/*.c) \
		  $(wildcard net/*.c)

OBJS		= $(patsubst %.c,%.o,$(wildcard *.c)) \
		  $(patsubst %.c,%.o,$(wildcard syscalls/*.c)) \
		  $(patsubst %.c,%.o,$(SYSCALLS_ARCH)) \
		  $(patsubst %.c,%.o,$(wildcard ioctls/*.c)) \
		  $(patsubst %.c,%.o,$(wildcard net/*.c))

DEPDIR= .deps

-include $(SRCS:%.c=$(DEPDIR)/%.d)

trinity: test $(OBJS) $(HEADERS)
	$(QUIET_CC)$(CC) $(CFLAGS) -o trinity $(OBJS)
	@mkdir -p tmp

df = $(DEPDIR)/$(*D)/$(*F)

%.o : %.c
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<
	@mkdir -p $(DEPDIR)/$(*D)
	@gcc -MM $(CFLAGS) $*.c > $(df).d
	@mv -f $(df).d $(df).d.tmp
	@sed -e 's|.*:|$*.o:|' <$(df).d.tmp > $(df).d
	@sed -e 's/.*://' -e 's/\\$$//' < $(df).d.tmp | fmt -1 | \
	  sed -e 's/^ *//' -e 's/$$/:/' >> $(df).d
	@rm -f $(df).d.tmp

clean:
	@rm -f $(OBJS)
	@rm -f core.*
	@rm -f trinity
	@rm -f tags
	@rm -rf $(DEPDIR)/*

devel:
	@perl -p -i -e 's/^#CFLAGS \+\= -Werror/CFLAGS += -Werror/' Makefile
	@perl -p -i -e 's/DEVEL=0/DEVEL=1/' configure.sh
	git commit Makefile -m "Enable -Werror"

release:
	@perl -p -i -e 's/^CFLAGS \+\= -Werror/#CFLAGS += -Werror/' Makefile
	@perl -p -i -e 's/DEVEL=1/DEVEL=0/' configure.sh
	git commit Makefile -m "Disable -Werror"

tag:
	git tag -a $(VERSION) -m "$(VERSION) release."

tarball:
	git repack -a -d
	git prune-packed
	git archive --format=tar.gz --prefix=trinity-$(VERSION)/ HEAD > trinity-$(VERSION).tgz

install:
	install -d -m 755 $(INSTALL_PREFIX)/bin
	install trinity $(INSTALL_PREFIX)/bin

tags:
	@ctags -R --exclude=tmp

mirror:
	@git push --mirror git@github.com:kernelslacker/trinity.git

scan:
	scan-build --use-analyzer=/usr/bin/clang make

coverity:
	cov-build --dir cov-int make
	tar czvf trinity-coverity.tgz cov-int

=== debian/changelog ===
trinity (1.2-1) unstable; urgency=low

  * New upstream version 1.2
  * Enable hardening options

 -- Anibal Monsalve Salazar <anibal@debian.org>  Tue, 23 Jul 2013 11:09:05 +1000

trinity (1.1-1) unstable; urgency=low

  * Initial release (Closes: #700506)

 -- gustavo panizzo <gfa@zumbi.com.ar>  Tue, 12 Feb 2013 23:40:12 -0300

=== debian/control ===
Source: trinity
Section: utils
Priority: optional
Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
Uploaders: Anibal Monsalve Salazar <anibal@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev, libdrm-dev, linux-headers-amd64 | linux-headers-generic | linux-headers
Standards-Version: 3.9.4
Homepage: http://codemonkey.org.uk/projects/trinity/
#Vcs-Git: git://git.debian.org/collab-maint/trinity.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/trinity.git;a=summary

Package: trinity
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: system call fuzz tester
 As 'fuzz testing' suggests, trinity calls syscalls at random, with random
 arguments. Where Trinity differs is that the arguments it passes are not
 purely random.
 .
 If a syscall took, for example, a file descriptor as an argument,
 one of the first things kernels does is validate that fd, if is not valid the
 kernel would just reject it as -EINVAL.
 .
 So on startup, Trinity creates a list of file descriptors, by opening pipes,
 scanning sysfs, procfs, /dev, and creates a bunch of sockets using random
 network protocols. Then when a syscall needs an fd, it gets passed one of
 these at random.
 .
 Trinity also shares those file descriptors between multiple threads, which
 causes havoc sometimes.
 .
 Warning: This program may seriously corrupt your files, including any of those
 that may be writable on mounted network file shares.  It may create network
 packets that may cause disruption on your local network.
 Run at your own risk.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:
	./configure.sh

override_dh_auto_install:
	make install DESTDIR=./usr

override_dh_clean:
	make clean
	rm -rf tmp
	rm -rf config.h

%:
	dh $@

## trinity 1.3

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,18 @@
-VERSION=1.2
+VERSION=1.3
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)
 
+ifeq ($(CC),"")
+CC := gcc
+endif
 CC := $(CROSS_COMPILE)$(CC)
 LD := $(CROSS_COMPILE)$(LD)
 
-CFLAGS = -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE
+CFLAGS := -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE
+ifneq ($(SYSROOT),)
+CFLAGS += --sysroot=$(SYSROOT)
+endif
 #CFLAGS += $(shell if $(CC) -m32 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-m32"; fi)
 CFLAGS += -Wdeclaration-after-statement
 CFLAGS += -Wformat=2
@@ -45,16 +51,18 @@
 HEADERS		= $(patsubst %.h,%.h,$(wildcard *.h)) $(patsubst %.h,%.h,$(wildcard syscalls/*.h)) $(patsubst %.h,%.h,$(wildcard ioctls/*.h))
 
 SRCS		= $(wildcard *.c) \
+		  $(wildcard children/*.c) \
+		  $(wildcard ioctls/*.c) \
+		  $(wildcard net/*.c) \
 		  $(wildcard syscalls/*.c) \
-		  $(SYSCALLS_ARCH) \
-		  $(wildcard ioctls/*.c) \
-		  $(wildcard net/*.c)
+		  $(SYSCALLS_ARCH)
 
-OBJS		= $(patsubst %.c,%.o,$(wildcard *.c)) \
-		  $(patsubst %.c,%.o,$(wildcard syscalls/*.c)) \
-		  $(patsubst %.c,%.o,$(SYSCALLS_ARCH)) \
-		  $(patsubst %.c,%.o,$(wildcard ioctls/*.c)) \
-		  $(patsubst %.c,%.o,$(wildcard net/*.c))
+OBJS		= $(sort $(patsubst %.c,%.o,$(wildcard *.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard children/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard ioctls/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard net/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard syscalls/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(SYSCALLS_ARCH)))
 
 DEPDIR= .deps
 
@@ -101,20 +109,21 @@
 	git prune-packed
 	git archive --format=tar.gz --prefix=trinity-$(VERSION)/ HEAD > trinity-$(VERSION).tgz
 
-install:
+install: trinity
 	install -d -m 755 $(INSTALL_PREFIX)/bin
 	install trinity $(INSTALL_PREFIX)/bin
 
-tags:
+tags:	$(SRCS)
 	@ctags -R --exclude=tmp
 
 mirror:
 	@git push --mirror git@github.com:kernelslacker/trinity.git
 
 scan:
-	scan-build --use-analyzer=/usr/bin/clang make
+	@scan-build --use-analyzer=/usr/bin/clang make
 
 coverity:
+	rm -rf cov-int trinity-coverity.tgz
 	cov-build --dir cov-int make
 	tar czvf trinity-coverity.tgz cov-int

=== debian/changelog ===
trinity (1.3-1) unstable; urgency=medium

  * New upstream version 1.3.
  * Removed wrong dependency on linux-headers. (Closes: #733771).

 -- gustavo panizzo <gfa@zumbi.com.ar>  Fri, 17 Jan 2014 21:10:15 -0300

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Uploaders: Anibal Monsalve Salazar <anibal@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev, libdrm-dev, linux-headers-amd64 | linux-headers-generic | linux-headers
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev, openstack-pkg-tools
+Standards-Version: 3.9.5
 Homepage: http://codemonkey.org.uk/projects/trinity/
-#Vcs-Git: git://git.debian.org/collab-maint/trinity.git
-#Vcs-Browser: http://git.debian.org/?p=collab-maint/trinity.git;a=summary
+Vcs-Git: git://anonscm.debian.org/collab-maint/trinity.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/trinity.git
 
 Package: trinity
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+include /usr/share/openstack-pkg-tools/pkgos.make
 
 override_dh_auto_configure:
 	./configure.sh
@@ -13,9 +14,12 @@
 	make install DESTDIR=./usr
 
 override_dh_clean:
+	dh_clean
 	make clean
 	rm -rf tmp
 	rm -rf config.h
+	rm -rf debian/trinity
+	rm -rf usr/
 
 %:
 	dh $@

=== debian/watch ===
version=3
http://codemonkey.org.uk/projects/trinity/trinity-(.*).tgz

## trinity 1.5

=== Makefile ===
VERSION="1.5"

INSTALL_PREFIX ?= $(DESTDIR)
INSTALL_PREFIX ?= $(HOME)
NR_CPUS := $(shell grep ^processor /proc/cpuinfo | /usr/bin/wc -l)

ifeq ($(CC),"")
CC := gcc
endif
CC := $(CROSS_COMPILE)$(CC)
LD := $(CROSS_COMPILE)$(LD)

CFLAGS += -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D__linux__
ifneq ($(SYSROOT),)
CFLAGS += --sysroot=$(SYSROOT)
endif
#CFLAGS += $(shell if $(CC) -m32 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-m32"; fi)
CFLAGS += -Wdeclaration-after-statement
CFLAGS += -Wformat=2
CFLAGS += -Winit-self
CFLAGS += -Wnested-externs
CFLAGS += -Wpacked
CFLAGS += -Wshadow
CFLAGS += -Wswitch-enum
CFLAGS += -Wundef
CFLAGS += -Wwrite-strings
CFLAGS += -Wno-format-nonliteral
CFLAGS += -Wstrict-prototypes -Wmissing-prototypes

# needed for show_backtrace() to work correctly.
LDFLAGS += -rdynamic

# gcc only.
ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
CFLAGS += -Wlogical-op
CFLAGS += -Wstrict-aliasing=3
endif

# Sometimes useful for debugging. more useful with clang than gcc.
#CFLAGS += -fsanitize=address

# Only enabled during development, and on gcc 4.8+
CPP_MAJOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f1)
CPP_MINOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f2)
DEVEL	:= $(shell grep VERSION Makefile | head -n1 | grep pre | wc -l)
CFLAGS	+= $(shell if [ $(CPP_MAJOR) -eq 4 -a $(CPP_MINOR) -ge 8 -a $(DEVEL) -eq 1 ] ; then echo "-Werror"; else echo ""; fi)

V	= @
Q	= $(V:1=)
QUIET_CC = $(Q:@=@echo    '  CC	'$@;)


all: trinity

version:
	@scripts/gen-versionh.sh

test:
	@if [ ! -f config.h ]; then  echo "[1;31mRun configure.sh first.[0m" ; exit; fi


MACHINE		= $(shell $(CC) -dumpmachine)
SYSCALLS_ARCH	= $(shell case "$(MACHINE)" in \
		  (sh*) echo syscalls/sh/*.c ;; \
		  (ia64*) echo syscalls/ia64/*.c ;; \
		  (ppc*|powerpc*) echo syscalls/ppc/*.c ;; \
		  (sparc*) echo syscalls/sparc/*.c ;; \
		  esac)

HEADERS		= $(patsubst %.h,%.h,$(wildcard *.h)) $(patsubst %.h,%.h,$(wildcard syscalls/*.h)) $(patsubst %.h,%.h,$(wildcard ioctls/*.h))

SRCS		= $(wildcard *.c) \
		  $(wildcard children/*.c) \
		  $(wildcard ioctls/*.c) \
		  $(wildcard net/*.c) \
		  $(wildcard syscalls/*.c) \
		  $(SYSCALLS_ARCH)

OBJS		= $(sort $(patsubst %.c,%.o,$(wildcard *.c))) \
		  $(sort $(patsubst %.c,%.o,$(wildcard children/*.c))) \
		  $(sort $(patsubst %.c,%.o,$(wildcard ioctls/*.c))) \
		  $(sort $(patsubst %.c,%.o,$(wildcard net/*.c))) \
		  $(sort $(patsubst %.c,%.o,$(wildcard syscalls/*.c))) \
		  $(sort $(patsubst %.c,%.o,$(SYSCALLS_ARCH)))

DEPDIR= .deps

-include $(SRCS:%.c=$(DEPDIR)/%.d)

trinity: version test $(OBJS) $(HEADERS)
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -o trinity $(OBJS)
	@mkdir -p tmp

df = $(DEPDIR)/$(*D)/$(*F)

%.o : %.c
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<
	@mkdir -p $(DEPDIR)/$(*D)
	@$(CC) -MM $(CFLAGS) $*.c > $(df).d
	@mv -f $(df).d $(df).d.tmp
	@sed -e 's|.*:|$*.o:|' <$(df).d.tmp > $(df).d
	@sed -e 's/.*://' -e 's/\\$$//' < $(df).d.tmp | fmt -1 | \
	  sed -e 's/^ *//' -e 's/$$/:/' >> $(df).d
	@rm -f $(df).d.tmp

clean:
	@rm -f $(OBJS)
	@rm -f core.*
	@rm -f trinity
	@rm -f tags
	@rm -rf $(DEPDIR)/*
	@rm -rf trinity-coverity.tar.xz cov-int
	@rm -f include/version.h

devel:
	@perl -p -i -e 's/DEVEL=0/DEVEL=1/' configure.sh
	@git commit Makefile configure.sh -m "Enable -Werror & devel mode"

release:
	@perl -p -i -e 's/DEVEL=1/DEVEL=0/' configure.sh
	@git commit Makefile configure.sh -m "Disable -Werror & devel mode"

tag:
	@git tag -a v$(VERSION) -m "$(VERSION) release."

tarball:
	@git repack -a -d
	@git prune-packed
	@git archive --format=tar --prefix=trinity-$(VERSION)/ HEAD > trinity-$(VERSION).tar
	@xz -9 trinity-$(VERSION).tar

install: trinity
	install -d -m 755 $(INSTALL_PREFIX)/bin
	install trinity $(INSTALL_PREFIX)/bin

tags:	$(SRCS)
	@ctags -R --exclude=tmp

scan:
	@scan-build --use-analyzer=/usr/bin/clang make

coverity:
	@rm -rf cov-int trinity-coverity.tar.xz
	@cov-build --dir cov-int make -j $(NR_CPUS)
	@tar cJvf trinity-coverity.tar.xz cov-int

=== debian/changelog ===
trinity (1.5-2) unstable; urgency=medium

  * Enable verbose build.
  * Fix FTBFS on mips/mipsel, thanks Arturo Borrero Gonzalez. (Closes: #790683).

 -- gustavo panizzo <gfa@zumbi.com.ar>  Wed, 01 Jul 2015 15:01:56 +0800

trinity (1.5-1) unstable; urgency=medium

  * New upstream release.
  * Upstream release fixes a bug in IA64 (Closes: #788695)
  * Upstream release fixes a bug building against newer kernels (Closes:
    #733770)
  * Updated standards version, no changes needed.

 -- gustavo panizzo <gfa@zumbi.com.ar>  Mon, 29 Jun 2015 13:08:59 +0800

trinity (1.4+git300714+fce8684-1) unstable; urgency=medium

  * Snapshot from git after new upstream release.
  * Watch file updated.

 -- gustavo panizzo <gfa@zumbi.com.ar>  Wed, 30 Jul 2014 20:34:47 -0300

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Uploaders: Anibal Monsalve Salazar <anibal@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev, openstack-pkg-tools
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev
+Standards-Version: 3.9.6
 Homepage: http://codemonkey.org.uk/projects/trinity/
 Vcs-Git: git://anonscm.debian.org/collab-maint/trinity.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/trinity.git

## trinity 1.6

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION="1.5"
+VERSION="1.6"
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)
@@ -11,6 +11,13 @@
 LD := $(CROSS_COMPILE)$(LD)
 
 CFLAGS += -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D__linux__
+
+# Only enabled during development, and on gcc 4.9+
+CPP_MAJOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f1)
+CPP_MINOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f2)
+DEVEL	:= $(shell grep VERSION Makefile | head -n1 | grep pre | wc -l)
+CFLAGS	+= $(shell if [ $(CPP_MAJOR) -eq 4 -a $(CPP_MINOR) -ge 9 -a $(DEVEL) -eq 1 ] ; then echo "-Werror"; else echo ""; fi)
+
 ifneq ($(SYSROOT),)
 CFLAGS += --sysroot=$(SYSROOT)
 endif
@@ -34,16 +41,11 @@
 ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
 CFLAGS += -Wlogical-op
 CFLAGS += -Wstrict-aliasing=3
+CFLAGS += $(shell if [ $(DEVEL) -eq 0 ]; then echo "-Wno-maybe-uninitialized"; else echo ""; fi)
 endif
 
 # Sometimes useful for debugging. more useful with clang than gcc.
 #CFLAGS += -fsanitize=address
-
-# Only enabled during development, and on gcc 4.8+
-CPP_MAJOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f1)
-CPP_MINOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f2)
-DEVEL	:= $(shell grep VERSION Makefile | head -n1 | grep pre | wc -l)
-CFLAGS	+= $(shell if [ $(CPP_MAJOR) -eq 4 -a $(CPP_MINOR) -ge 8 -a $(DEVEL) -eq 1 ] ; then echo "-Werror"; else echo ""; fi)
 
 V	= @
 Q	= $(V:1=)
@@ -71,15 +73,21 @@
 
 SRCS		= $(wildcard *.c) \
 		  $(wildcard children/*.c) \
+		  $(wildcard fds/*.c) \
 		  $(wildcard ioctls/*.c) \
+		  $(wildcard mm/*.c) \
 		  $(wildcard net/*.c) \
+		  $(wildcard rand/*.c) \
 		  $(wildcard syscalls/*.c) \
 		  $(SYSCALLS_ARCH)
 
 OBJS		= $(sort $(patsubst %.c,%.o,$(wildcard *.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard children/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard fds/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard ioctls/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard mm/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard net/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard rand/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard syscalls/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(SYSCALLS_ARCH)))
 
@@ -112,20 +120,10 @@
 	@rm -rf trinity-coverity.tar.xz cov-int
 	@rm -f include/version.h
 
-devel:
-	@perl -p -i -e 's/DEVEL=0/DEVEL=1/' configure.sh
-	@git commit Makefile configure.sh -m "Enable -Werror & devel mode"
-
-release:
-	@perl -p -i -e 's/DEVEL=1/DEVEL=0/' configure.sh
-	@git commit Makefile configure.sh -m "Disable -Werror & devel mode"
-
 tag:
 	@git tag -a v$(VERSION) -m "$(VERSION) release."
 
 tarball:
-	@git repack -a -d
-	@git prune-packed
 	@git archive --format=tar --prefix=trinity-$(VERSION)/ HEAD > trinity-$(VERSION).tar
 	@xz -9 trinity-$(VERSION).tar
 
@@ -137,7 +135,7 @@
 	@ctags -R --exclude=tmp
 
 scan:
-	@scan-build --use-analyzer=/usr/bin/clang make
+	@scan-build --use-analyzer=/usr/bin/clang make -j $(NR_CPUS)
 
 coverity:
 	@rm -rf cov-int trinity-coverity.tar.xz

=== tools/Makefile ===
ifeq ($(CC),"")
CC := gcc
endif
CC := $(CROSS_COMPILE)$(CC)
LD := $(CROSS_COMPILE)$(LD)

CFLAGS += -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D__linux__
ifneq ($(SYSROOT),)
CFLAGS += --sysroot=$(SYSROOT)
endif
#CFLAGS += $(shell if $(CC) -m32 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-m32"; fi)
CFLAGS += -Wdeclaration-after-statement
CFLAGS += -Wformat=2
CFLAGS += -Winit-self
CFLAGS += -Wnested-externs
CFLAGS += -Wpacked
CFLAGS += -Wshadow
CFLAGS += -Wswitch-enum
CFLAGS += -Wundef
CFLAGS += -Wwrite-strings
CFLAGS += -Wno-format-nonliteral
CFLAGS += -Wstrict-prototypes -Wmissing-prototypes

# gcc only.
ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
CFLAGS += -Wlogical-op
CFLAGS += -Wstrict-aliasing=3
endif

V	= @
Q	= $(V:1=)
QUIET_CC = $(Q:@=@echo    '  CC	'$@;)

all: analyze-sockets

analyze-sockets:
	$(QUIET_CC)$(CC) $(CFLAGS) analyze-sockets.c -o analyze-sockets

clean:
	@rm -f core.*
	@rm -f analyze-sockets

=== debian/changelog ===
trinity (1.6-2) unstable; urgency=medium

  * Fix build issues on mips*. 
  * Upload to unstable.

 -- gustavo panizzo <gfa@zumbi.com.ar>  Thu, 17 Mar 2016 12:07:56 +0000

trinity (1.6-1) experimental; urgency=medium

  * Start packaging over using a new upstream tree.
  * New upstream release.
  * Bumped standard version to 3.9.7, no changes were needed.
  * Bumped debhelper compat level, no changes were needed.
  * Use secure URI for VCS-* fields. 
  * Upload to experimental.
  * Update upstream changelog.
  * Update debian/copyright.

 -- gustavo panizzo <gfa@zumbi.com.ar>  Tue, 08 Mar 2016 10:14:22 +0000

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Uploaders: Anibal Monsalve Salazar <anibal@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://codemonkey.org.uk/projects/trinity/
-Vcs-Git: git://anonscm.debian.org/collab-maint/trinity.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/trinity.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/trinity.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/trinity.git
 
 Package: trinity
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,9 @@
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-include /usr/share/openstack-pkg-tools/pkgos.make
 
 override_dh_auto_configure:
+	perl -p -i -e 's/DEVEL=1/DEVEL=0/' configure.sh
 	./configure.sh
 
 override_dh_auto_install:
@@ -21,5 +21,12 @@
 	rm -rf debian/trinity
 	rm -rf usr/
 
+override_dh_installchangelogs:
+	if [ -e $(CURDIR)/debian/CHANGELOG ] ; then \
+		dh_installchangelogs $(CURDIR)/debian/CHANGELOG ; \
+	else \
+		dh_installchangelogs ; \
+	fi
+
 %:
 	dh $@

## trinity 1.7~git20161005

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION="1.6"
+VERSION="1.7pre"
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)
@@ -10,13 +10,15 @@
 CC := $(CROSS_COMPILE)$(CC)
 LD := $(CROSS_COMPILE)$(LD)
 
-CFLAGS += -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D__linux__
+CFLAGS += -Wall -Wextra -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D__linux__
+
+CFLAGS += $(shell if $(CC) -std=gnu11 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-std=gnu11"; else echo "-std=gnu99"; fi)
 
 # Only enabled during development, and on gcc 4.9+
 CPP_MAJOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f1)
 CPP_MINOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f2)
 DEVEL	:= $(shell grep VERSION Makefile | head -n1 | grep pre | wc -l)
-CFLAGS	+= $(shell if [ $(CPP_MAJOR) -eq 4 -a $(CPP_MINOR) -ge 9 -a $(DEVEL) -eq 1 ] ; then echo "-Werror"; else echo ""; fi)
+CFLAGS	+= $(shell if [ $(CPP_MAJOR) -eq 5 -a $(CPP_MINOR) -ge 1 -a $(DEVEL) -eq 1 ] ; then echo "-Werror"; else echo ""; fi)
 
 ifneq ($(SYSROOT),)
 CFLAGS += --sysroot=$(SYSROOT)
@@ -36,6 +38,9 @@
 
 # needed for show_backtrace() to work correctly.
 LDFLAGS += -rdynamic
+
+# glibc versions before 2.17 for clock_gettime
+LDLIBS += -lrt
 
 # gcc only.
 ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
@@ -67,12 +72,17 @@
 		  (ia64*) echo syscalls/ia64/*.c ;; \
 		  (ppc*|powerpc*) echo syscalls/ppc/*.c ;; \
 		  (sparc*) echo syscalls/sparc/*.c ;; \
+		  (x86_64*) echo syscalls/x86/*.c \
+				 syscalls/x86/i386/*.c \
+				 syscalls/x86/x86_64/*.c;; \
+		  (i?86*) echo syscalls/x86/*.c \
+			       syscalls/x86/i386/*.c;; \
 		  esac)
 
 HEADERS		= $(patsubst %.h,%.h,$(wildcard *.h)) $(patsubst %.h,%.h,$(wildcard syscalls/*.h)) $(patsubst %.h,%.h,$(wildcard ioctls/*.h))
 
 SRCS		= $(wildcard *.c) \
-		  $(wildcard children/*.c) \
+		  $(wildcard childops/*.c) \
 		  $(wildcard fds/*.c) \
 		  $(wildcard ioctls/*.c) \
 		  $(wildcard mm/*.c) \
@@ -82,7 +92,7 @@
 		  $(SYSCALLS_ARCH)
 
 OBJS		= $(sort $(patsubst %.c,%.o,$(wildcard *.c))) \
-		  $(sort $(patsubst %.c,%.o,$(wildcard children/*.c))) \
+		  $(sort $(patsubst %.c,%.o,$(wildcard childops/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard fds/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard ioctls/*.c))) \
 		  $(sort $(patsubst %.c,%.o,$(wildcard mm/*.c))) \
@@ -96,7 +106,7 @@
 -include $(SRCS:%.c=$(DEPDIR)/%.d)
 
 trinity: version test $(OBJS) $(HEADERS)
-	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -o trinity $(OBJS)
+	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -o trinity $(OBJS) $(LDLIBS)
 	@mkdir -p tmp
 
 df = $(DEPDIR)/$(*D)/$(*F)
@@ -142,3 +152,5 @@
 	@cov-build --dir cov-int make -j $(NR_CPUS)
 	@tar cJvf trinity-coverity.tar.xz cov-int
 
+cppcheck:
+	@scripts/cppcheck.sh

=== debian/changelog ===
trinity (1.7~git20161005-1) unstable; urgency=medium

  * Packaging an upstream snapshot
  * Drop patches to build on mips, as they were applied upstream
  * Remove unnecessary overrides from debian/rules
    - dh_clean replaced with clean target
    - dh_auto_configure upstream changed configure script
  * Add clean target to debian/rules
  * Update upstream changelog
  * Bumped standard version to 3.9.8, no changes were needed
  * Store the generated tarball using pristine-tar
  * Override 2 lintian warnings
    Reasoning for the overrides is on the debian/trinity.lintian-overrides
    file
  * Install the manpage provided by upstream

 -- gustavo panizzo <gfa@zumbi.com.ar>  Wed, 12 Oct 2016 12:24:49 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_install:
	make install DESTDIR=./usr

override_dh_installchangelogs:
	if [ -e $(CURDIR)/debian/CHANGELOG ] ; then \
		dh_installchangelogs $(CURDIR)/debian/CHANGELOG ; \
	else \
		dh_installchangelogs ; \
	fi

clean:
	make clean
	dh_clean usr/bin/trinity config.h

%:
	dh $@

## trinity 1.7

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION="1.7pre"
+VERSION="1.7"
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)

=== debian/changelog ===
trinity (1.7-1) unstable; urgency=medium

  * New upstream release
  * Enable all hardening flags
  * Remove lintian overrides
  * Update upstream changelog
  * Enable verbose build (Closes: #790719)
  * Partially revert commit 6966190, replace clean target in debian/rules
    by a dh_clean override.

 -- gustavo panizzo <gfa@zumbi.com.ar>  Fri, 11 Nov 2016 16:51:24 +0800

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Uploaders: Anibal Monsalve Salazar <anibal@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://codemonkey.org.uk/projects/trinity/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/trinity.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/trinity.git

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 override_dh_auto_install:
 	make install DESTDIR=./usr
@@ -16,9 +17,11 @@
 		dh_installchangelogs ; \
 	fi
 
-clean:
+override_dh_clean:
 	make clean
 	dh_clean usr/bin/trinity config.h
 
+override_dh_auto_build:
+	make V=1
 %:
 	dh $@

## trinity 1.8

=== Makefile ===
VERSION="1.8"

ifeq (,$(findstring pre,$(VERSION)))
DEVEL = 0
else
DEVEL = 1
endif

INSTALL_PREFIX ?= $(DESTDIR)
INSTALL_PREFIX ?= $(HOME)
NR_CPUS := $(shell grep -c ^processor /proc/cpuinfo)

ifeq ($(CC),"")
CC := gcc
endif
CC := $(CROSS_COMPILE)$(CC)
LD := $(CROSS_COMPILE)$(LD)

CFLAGS ?= -g -O2 -D_FORTIFY_SOURCE=2
CFLAGS += -Wall -Wextra -I. -Iinclude/ -include config.h -Wimplicit -D_GNU_SOURCE -D__linux__

CCSTD := $(shell if $(CC) -std=gnu11 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-std=gnu11"; else echo "-std=gnu99"; fi)
CFLAGS += $(CCSTD)

# -Werror only enabled during development, and on gcc 7+
ifeq ($(DEVEL), 1)
CPP_MAJOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f1)
CPP_MINOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f2)
WERROR	:= $(shell if [ $(CPP_MAJOR) -ge 7 ] ; then echo "-Werror"; else echo ""; fi)
CFLAGS	+= $(WERROR)
endif

ifneq ($(SYSROOT),)
CFLAGS += --sysroot=$(SYSROOT)
endif
#CFLAGS += $(shell if $(CC) -m32 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-m32"; fi)
CFLAGS += -Wdeclaration-after-statement
CFLAGS += -Wformat=2
CFLAGS += -Winit-self
CFLAGS += -Wnested-externs
CFLAGS += -Wpacked
CFLAGS += -Wshadow
CFLAGS += -Wswitch-enum
CFLAGS += -Wundef
CFLAGS += -Wwrite-strings
CFLAGS += -Wno-format-nonliteral
CFLAGS += -Wstrict-prototypes -Wmissing-prototypes
CFLAGS += -fsigned-char

# needed for show_backtrace() to work correctly.
LDFLAGS += -rdynamic

# glibc versions before 2.17 for clock_gettime
LDLIBS += -lrt

# gcc only.
ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
CFLAGS += -Wlogical-op
CFLAGS += -Wstrict-aliasing=3
ifeq ($(DEVEL), 0)
CFLAGS += -Wno-maybe-uninitialized
endif
endif

# Sometimes useful for debugging. more useful with clang than gcc.
#CFLAGS += -fsanitize=address

V	= @
Q	= $(V:1=)
QUIET_CC = $(Q:@=@echo    '  CC	'$@;)


all: trinity

test:
	@if [ ! -f config.h ]; then  echo "[1;31mRun configure.sh first.[0m" ; exit; fi


MACHINE		:= $(shell $(CC) -dumpmachine)
SYSCALLS_ARCH	:= $(shell case "$(MACHINE)" in \
		   (sh*) echo syscalls/sh/*.c ;; \
		   (ia64*) echo syscalls/ia64/*.c ;; \
		   (ppc*|powerpc*) echo syscalls/ppc/*.c ;; \
		   (sparc*) echo syscalls/sparc/*.c ;; \
		   (x86_64*) echo syscalls/x86/*.c \
				  syscalls/x86/i386/*.c \
				  syscalls/x86/x86_64/*.c;; \
		   (i?86*) echo syscalls/x86/*.c \
				syscalls/x86/i386/*.c;; \
		   esac)

VERSION_H	:= include/version.h

HEADERS		:= $(patsubst %.h,%.h,$(wildcard *.h)) $(patsubst %.h,%.h,$(wildcard syscalls/*.h)) $(patsubst %.h,%.h,$(wildcard ioctls/*.h))

SRCS		:= $(wildcard *.c) \
		   $(wildcard childops/*.c) \
		   $(wildcard fds/*.c) \
		   $(wildcard ioctls/*.c) \
		   $(wildcard mm/*.c) \
		   $(wildcard net/*.c) \
		   $(wildcard rand/*.c) \
		   $(wildcard syscalls/*.c) \
		   $(SYSCALLS_ARCH)

OBJS		:= $(sort $(patsubst %.c,%.o,$(wildcard *.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard childops/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard fds/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard ioctls/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard mm/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard net/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard rand/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(wildcard syscalls/*.c))) \
		   $(sort $(patsubst %.c,%.o,$(SYSCALLS_ARCH)))

DEPDIR= .deps

-include $(SRCS:%.c=$(DEPDIR)/%.d)

$(VERSION_H): scripts/gen-versionh.sh Makefile $(wildcard .git)
	@scripts/gen-versionh.sh

trinity: test $(OBJS) $(HEADERS)
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -o trinity $(OBJS) $(LDLIBS)
	@mkdir -p tmp

df = $(DEPDIR)/$(*D)/$(*F)

%.o : %.c | $(VERSION_H)
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<
	@mkdir -p $(DEPDIR)/$(*D)
	@$(CC) -MM $(CFLAGS) $*.c > $(df).d
	@mv -f $(df).d $(df).d.tmp
	@sed -e 's|.*:|$*.o:|' <$(df).d.tmp > $(df).d
	@sed -e 's/.*://' -e 's/\\$$//' < $(df).d.tmp | fmt -1 | \
	  sed -e 's/^ *//' -e 's/$$/:/' >> $(df).d
	@rm -f $(df).d.tmp

clean:
	@rm -f $(OBJS)
	@rm -f core.*
	@rm -f trinity
	@rm -f tags
	@rm -rf $(DEPDIR)/*
	@rm -rf trinity-coverity.tar.xz cov-int
	@rm -f $(VERSION_H)

tag:
	@git tag -a v$(VERSION) -m "$(VERSION) release."

tarball:
	@git archive --format=tar --prefix=trinity-$(VERSION)/ HEAD > trinity-$(VERSION).tar
	@xz -9 trinity-$(VERSION).tar

install: trinity
	install -d -m 755 $(INSTALL_PREFIX)/bin
	install trinity $(INSTALL_PREFIX)/bin

tags:	$(SRCS)
	@ctags -R --exclude=tmp

scan:
	@scan-build --use-analyzer=/usr/bin/clang make -j $(NR_CPUS)

coverity:
	@rm -rf cov-int trinity-coverity.tar.xz
	@cov-build --dir cov-int make -j $(NR_CPUS)
	@tar cJvf trinity-coverity.tar.xz cov-int

cppcheck:
	@scripts/cppcheck.sh

=== server/Makefile ===
NR_CPUS := $(shell grep -c ^processor /proc/cpuinfo)

CFLAGS ?= -g -O2 -D_FORTIFY_SOURCE=2
CFLAGS += -Wall -Wextra -I. -I../include/ -Wimplicit -D_GNU_SOURCE -D__linux__

CCSTD := $(shell if $(CC) -std=gnu11 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-std=gnu11"; else echo "-std=gnu99"; fi)
CFLAGS += $(CCSTD)

CFLAGS += -Wdeclaration-after-statement
CFLAGS += -Wformat=2
CFLAGS += -Winit-self
CFLAGS += -Wnested-externs
CFLAGS += -Wpacked
CFLAGS += -Wshadow
CFLAGS += -Wundef
CFLAGS += -Wwrite-strings
CFLAGS += -Wno-format-nonliteral
CFLAGS += -Wstrict-prototypes -Wmissing-prototypes

# gcc only.
ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
CFLAGS += -Wlogical-op
CFLAGS += -Wstrict-aliasing=3
ifeq ($(DEVEL), 0)
CFLAGS += -Wno-maybe-uninitialized
endif
endif

# Sometimes useful for debugging. more useful with clang than gcc.
#CFLAGS += -fsanitize=address

LDFLAGS = -lpthread

V	= @
Q	= $(V:1=)
QUIET_CC = $(Q:@=@echo    '  CC	'$@;)


all: trinityserver

HEADERS		:= $(patsubst %.h,%.h,$(wildcard *.h))

SRCS		:= $(wildcard *.c)

OBJS		:= $(sort $(patsubst %.c,%.o,$(wildcard *.c)))

DEPDIR= .deps

-include $(SRCS:%.c=$(DEPDIR)/%.d)

trinityserver: $(OBJS) $(HEADERS)
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -o trinityserver $(OBJS) $(LDLIBS)

df = $(DEPDIR)/$(*D)/$(*F)

%.o : %.c
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<
	@mkdir -p $(DEPDIR)/$(*D)
	@$(CC) -MM $(CFLAGS) $*.c > $(df).d
	@mv -f $(df).d $(df).d.tmp
	@sed -e 's|.*:|$*.o:|' <$(df).d.tmp > $(df).d
	@sed -e 's/.*://' -e 's/\\$$//' < $(df).d.tmp | fmt -1 | \
	  sed -e 's/^ *//' -e 's/$$/:/' >> $(df).d
	@rm -f $(df).d.tmp

clean:
	@rm -f $(OBJS)
	@rm -f core.*
	@rm -f trinityserver

=== tools/Makefile ===
--- 
+++ 
@@ -4,7 +4,8 @@
 CC := $(CROSS_COMPILE)$(CC)
 LD := $(CROSS_COMPILE)$(LD)
 
-CFLAGS += -Wall -W -g -O2 -I. -Iinclude/ -Wimplicit -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D__linux__
+CFLAGS ?= -g -O2 -D_FORTIFY_SOURCE=2
+CFLAGS += -Wall -W -I. -Iinclude/ -Wimplicit -D_GNU_SOURCE -D__linux__
 ifneq ($(SYSROOT),)
 CFLAGS += --sysroot=$(SYSROOT)
 endif

=== debian/changelog ===
trinity (1.8-6) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

  [ gustavo panizzo ]
  * Add a patch to fix FTBFS on kernels without VIDIOC_RESERVED (Closes:
    #917664)
  * Use compat level 11
  * Bump standards version to 4.3.0, no changes were needed
  * Add a patch to skip irda tests when the header is missing

 -- gustavo panizzo <gfa@zumbi.com.ar>  Mon, 31 Dec 2018 14:05:28 +0800

trinity (1.8-5) unstable; urgency=medium

  * Use an upstream patch to fix a FTBFS (Closes: #906511).

 -- gustavo panizzo <gfa@zumbi.com.ar>  Tue, 28 Aug 2018 15:55:36 +0800

trinity (1.8-4) unstable; urgency=medium

  * Add patch to correctly build on Ubuntu, thanks Jeremy Bicha
  * Fix autopkg test (Closes: #894646)

 -- gustavo panizzo <gfa@zumbi.com.ar>  Wed, 04 Apr 2018 19:02:15 +0800

trinity (1.8-3) unstable; urgency=medium

  * Backport an upstream patch to build against glibc 2.27 (Closes: #891293)
  * Bumped standards version to 4.1.3, no changes were needed
  * Add minimal autopkg tests

 -- gustavo panizzo <gfa@zumbi.com.ar>  Wed, 21 Mar 2018 15:13:33 +0000

trinity (1.8-2) unstable; urgency=medium

  * Fix FTBFS against linux-libc-dev 4.12 (Closes: #884034)
  * Bumped standards version to 4.1.2, no changes were needed
  * Update VCS-* fields to use salsa.debian.org

 -- gustavo panizzo <gfa@zumbi.com.ar>  Tue, 26 Dec 2017 10:22:12 +0800

trinity (1.8-1) unstable; urgency=medium

  * New upstream release
  * Bumped standard version to 4.1.1, no changes were needed
  * Remove Anibal from Uploaders field, thanks for the previous sponsoring
  * Update upstream changelog
  * Build the server

 -- gustavo panizzo <gfa@zumbi.com.ar>  Sat, 18 Nov 2017 13:50:38 +0800

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Section: utils
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
-Uploaders: Anibal Monsalve Salazar <anibal@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), linux-libc-dev
+Standards-Version: 4.3.0
 Homepage: http://codemonkey.org.uk/projects/trinity/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/trinity.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/trinity.git
+Vcs-Git: https://salsa.debian.org/debian/trinity.git
+Vcs-Browser: https://salsa.debian.org/debian/trinity
 
 Package: trinity
 Architecture: any

=== debian/tests/control ===
Tests: run-trinity--help

## trinity 1.9

=== debian/changelog ===
trinity (1.9-lnd.4) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 19:51:02 +0800

trinity (1.9-lnd.3) unstable; urgency=medium

  * Fix ctrl-c problem caused by create_timer test

 -- Hongchen Zhang <zhanghongchen@loongson.cn>  Wed, 1 Dec 2021 10:00:36 +0800

trinity (1.9-lnd.2) unstable; urgency=medium

  * fix some SEGV problem

 -- Hongchen Zhang <zhanghongchen@loongson.cn>  Tue, 16 Nov 2021 20:11:00 +0800

trinity (1.9-1.lnd.1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>
  * Add loongarch basic support

 -- Qing Zhang <zhangqing@loongson.cn>  Thu, 29 Jul 2021 15:11:00 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.1.3
 Homepage: http://codemonkey.org.uk/projects/trinity/
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

override_dh_auto_install:
	dh_auto_install -- DESTDIR=./usr
override_dh_clean:
	make clean
	dh_clean usr/bin/trinity config.h

%:
	dh $@

## trinity 1.9%2Bgit20200331.4d2343bd18c7b

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,4 @@
-VERSION="1.8"
-
-ifeq (,$(findstring pre,$(VERSION)))
-DEVEL = 0
-else
-DEVEL = 1
-endif
+VERSION="2019.06"
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)
@@ -22,14 +16,6 @@
 CCSTD := $(shell if $(CC) -std=gnu11 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-std=gnu11"; else echo "-std=gnu99"; fi)
 CFLAGS += $(CCSTD)
 
-# -Werror only enabled during development, and on gcc 7+
-ifeq ($(DEVEL), 1)
-CPP_MAJOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f1)
-CPP_MINOR := $(shell $(CPP) -dumpversion 2>&1 | cut -d'.' -f2)
-WERROR	:= $(shell if [ $(CPP_MAJOR) -ge 7 ] ; then echo "-Werror"; else echo ""; fi)
-CFLAGS	+= $(WERROR)
-endif
-
 ifneq ($(SYSROOT),)
 CFLAGS += --sysroot=$(SYSROOT)
 endif
@@ -46,6 +32,8 @@
 CFLAGS += -Wno-format-nonliteral
 CFLAGS += -Wstrict-prototypes -Wmissing-prototypes
 CFLAGS += -fsigned-char
+# BPF spew.
+CFLAGS += -Wno-missing-field-initializers
 
 # needed for show_backtrace() to work correctly.
 LDFLAGS += -rdynamic
@@ -57,9 +45,6 @@
 ifneq ($(shell $(CC) -v 2>&1 | grep -c "clang"), 1)
 CFLAGS += -Wlogical-op
 CFLAGS += -Wstrict-aliasing=3
-ifeq ($(DEVEL), 0)
-CFLAGS += -Wno-maybe-uninitialized
-endif
 endif
 
 # Sometimes useful for debugging. more useful with clang than gcc.
@@ -87,6 +72,7 @@
 				  syscalls/x86/x86_64/*.c;; \
 		   (i?86*) echo syscalls/x86/*.c \
 				syscalls/x86/i386/*.c;; \
+		   (s390x*) echo syscalls/s390x/*.c ;; \
 		   esac)
 
 VERSION_H	:= include/version.h
@@ -94,7 +80,6 @@
 HEADERS		:= $(patsubst %.h,%.h,$(wildcard *.h)) $(patsubst %.h,%.h,$(wildcard syscalls/*.h)) $(patsubst %.h,%.h,$(wildcard ioctls/*.h))
 
 SRCS		:= $(wildcard *.c) \
-		   $(wildcard childops/*.c) \
 		   $(wildcard fds/*.c) \
 		   $(wildcard ioctls/*.c) \
 		   $(wildcard mm/*.c) \
@@ -104,7 +89,6 @@
 		   $(SYSCALLS_ARCH)
 
 OBJS		:= $(sort $(patsubst %.c,%.o,$(wildcard *.c))) \
-		   $(sort $(patsubst %.c,%.o,$(wildcard childops/*.c))) \
 		   $(sort $(patsubst %.c,%.o,$(wildcard fds/*.c))) \
 		   $(sort $(patsubst %.c,%.o,$(wildcard ioctls/*.c))) \
 		   $(sort $(patsubst %.c,%.o,$(wildcard mm/*.c))) \

## trinity 1.9%2Bgit20230728.e71872454d26

=== debian/changelog ===
trinity (1.9+git20230728.e71872454d26-1) unstable; urgency=medium

  * Package an upstream snapshot (Closes: #1042224)

 -- gustavo panizzo <gfa@zumbi.com.ar>  Fri, 28 Jul 2023 23:14:24 +0200

trinity (1.9+git20230109.87f1530-1) unstable; urgency=medium

  * Package an upstream snapshot (Closes: #1028795)
  * [1214da] Update copyright years
  * [398f7c] Bump standards version to 4.6.2, no changes were needed

 -- gustavo panizzo <gfa@zumbi.com.ar>  Mon, 23 Jan 2023 22:08:07 +0100

trinity (1.9+git20220923.e63e484-1) unstable; urgency=medium

  * Package an upstream snapshot (Closes: #1019271)
  * [a0b23a] Update the copyright years
  * [f3e0b2] Update the homepage of the project
  * [efa9af] Bump standards version to 4.6.0.1, no changes were needed

 -- gustavo panizzo <gfa@zumbi.com.ar>  Sun, 25 Sep 2022 17:34:56 +0200

trinity (1.9+git20200331.4d2343bd18c7b-2) unstable; urgency=medium

  * [c24aa6] Make the build verbose by default.
    Thanks to Helmut Grohne <helmut@subdivi.de> (Closes: 956024)
  * [23017d] Mark tests as superficial (Closes: 971505)
  * [d510fa] Use debhelper-compat level 13

 -- gustavo panizzo <gfa@zumbi.com.ar>  Thu, 29 Oct 2020 21:12:17 +0000

trinity (1.9+git20200331.4d2343bd18c7b-1) unstable; urgency=medium

  * Package an upstream snapshot (Closes: #954588)
  * [484354] Remove outdated patches
  * [1f0336] No longer ship a CHANGELOG
  * [c7bd50] Bump standards version to 4.5.0, no changes were needed
  * [7e0f3a] Use debhelper-compat level 12
  * [919f9f] Add upstream metadata
  * [8b954c] The logging server has been removed, remove its references
    from packaging
  * [fd6397] Add Rules-Requires-Root: no to d/rules

 -- gustavo panizzo <gfa@zumbi.com.ar>  Tue, 31 Mar 2020 21:57:23 +0000

## trinity 1.9%2Bgit20241022.ba2360ed84a8

=== debian/changelog ===
trinity (1.9+git20241022.ba2360ed84a8-1deepin1) unstable; urgency=medium

  * add LoongArch64 support.

 -- lichenggang <lichenggang@deepin.org>  Wed, 19 Mar 2025 15:43:39 +0800

trinity (1.9+git20241022.ba2360ed84a8-1) unstable; urgency=medium

  * Package an upstream snapshot (Closes: #1022231)
  * [7bf515] Bump standards version to 4.7.0, no changes were needed
  * [13f3ba] Update copyright years
  * [e3c0e0] Change the shebang of a script to be able to use bash features

 -- gustavo panizzo <gfa@zumbi.com.ar>  Tue, 22 Oct 2024 05:58:12 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: utils
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
-Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.1.3
-Homepage: http://codemonkey.org.uk/projects/trinity/
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), linux-libc-dev
+Standards-Version: 4.7.0
+Homepage: https://github.com/kernelslacker/trinity
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity
+Rules-Requires-Root: no
 
 Package: trinity
 Architecture: any

## trinity 1.9%2Bgit20250902.294c465

=== debian/changelog ===
trinity (1.9+git20250902.294c465-1) unstable; urgency=medium

  * QA upload.

  [ Boyuan Yang ]
  * New upstream snapshot.
  * Orphan the package. (See #1114568)
  * Bump Standards-Version to 4.7.3.
  * debian/watch: Update to version 5.
  * debian/gbp.conf: Follow dep-14.

  [ Ural Tunaboyu ]
  * d/rules: exclude build flags to enable frame pointers (LP: #2114228)

 -- Boyuan Yang <byang@debian.org>  Sat, 03 Jan 2026 13:44:54 -0500

## trinity 1.9+git20200331.4d2343bd18c7b

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.7.0
-Homepage: https://github.com/kernelslacker/trinity
+Standards-Version: 4.5.0
+Homepage: http://codemonkey.org.uk/projects/trinity/
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity
 Rules-Requires-Root: no

=== debian/tests/control ===
Tests: run-trinity--help
Restrictions: superficial

## trinity 1.9+git20220923.e63e484

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION="2019.06"
+VERSION="2021.10"
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)
@@ -20,7 +20,6 @@
 CFLAGS += --sysroot=$(SYSROOT)
 endif
 #CFLAGS += $(shell if $(CC) -m32 -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo "-m32"; fi)
-CFLAGS += -Wdeclaration-after-statement
 CFLAGS += -Wformat=2
 CFLAGS += -Winit-self
 CFLAGS += -Wnested-externs

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.5.0
-Homepage: http://codemonkey.org.uk/projects/trinity/
+Standards-Version: 4.6.0.1
+Homepage: https://github.com/kernelslacker/trinity
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity
 Rules-Requires-Root: no

## trinity 1.9+git20230109.87f1530

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/kernelslacker/trinity
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity

## trinity 1.9+git20230728.e71872454d26

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
override_dh_auto_build:
	dh_auto_build -- V=1
endif

override_dh_auto_install:
	make install DESTDIR=./usr

override_dh_clean:
	make clean
	dh_clean usr/bin/trinity config.h

%:
	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/trinity-$1\.tar\.gz/ \
  https://github.com/kernelslacker/trinity/tags .*/v?(\d\S*)\.tar\.gz

## trinity 1.9+git20241022.ba2360ed84a8

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION="2021.10"
+VERSION="2023.01"
 
 INSTALL_PREFIX ?= $(DESTDIR)
 INSTALL_PREFIX ?= $(HOME)

=== debian/changelog ===
trinity (1.9+git20241022.ba2360ed84a8-1ubuntu1) questing; urgency=medium

  * d/rules: exclude build flags to enable frame pointers (LP: #2114228)

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Thu, 12 Jun 2025 13:12:15 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: trinity
 Section: utils
 Priority: optional
-Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/kernelslacker/trinity
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity

## trinity 1.9+git20250902.294c465

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,11 @@
 Source: trinity
 Section: utils
-Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: gustavo panizzo <gfa@zumbi.com.ar>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), linux-libc-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/kernelslacker/trinity
 Vcs-Git: https://salsa.debian.org/debian/trinity.git
 Vcs-Browser: https://salsa.debian.org/debian/trinity
-Rules-Requires-Root: no
-
-Package: trinity
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: system call fuzz tester
  As 'fuzz testing' suggests, trinity calls syscalls at random, with random
  arguments. Where Trinity differs is that the arguments it passes are not
@@ -34,3 +27,9 @@
  that may be writable on mounted network file shares.  It may create network
  packets that may cause disruption on your local network.
  Run at your own risk.
+
+Package: trinity
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: ${source:Synopsis}
+ ${source:Extended-Description}

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,10 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+# https://bugs.launchpad.net/ubuntu/+source/trinity/+bug/2114228
+# https://salsa.debian.org/debian/trinity/-/merge_requests/2
+export DEB_CFLAGS_MAINT_STRIP=-fno-omit-frame-pointer -mno-omit-leaf-frame-pointer
 
 ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_build:

=== debian/watch ===
Version: 5

Source: https://github.com/kernelslacker/trinity
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 1.9+git%cd.%h
